Biblioteka/Models/Book.cs
using FluentNHibernate.Mapping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace Biblioteka.Models
{
    public class Book
    {
        public virtual int Id { get; set; }

        [Required]
        public virtual Author Author { get; set; }

        [Required]
        [System.Web.Mvc.Remote("IsTitleExist", "Book",
        ErrorMessage = "Book title already exists")]
        public virtual string Title { get; set; }
        public virtual string ISBN { get; set; }

        [DisplayName("Table of contents")]
        public virtual string TableOfContents { get; set; }
        public virtual string Description { get; set; }

        [Required]
        public virtual Category Category { get; set; }

        public virtual IList<Tag> Tags { get; set; }

        public virtual string FullName
        {
            get
            {
                return Author.Name + " " + Author.Surname;
            }
        }
        public Book()
        {
            Tags = new List<Tag>();
        }

        public class Map : ClassMap<Book>
        {
            public Map()
            {
                Table("Books");
                Id(x => x.Id).GeneratedBy.Identity();
                References(x => x.Author).Column("AuthorId");
                Map(x => x.Title).Not.Nullable().Unique();
                Map(x => x.ISBN).Not.Nullable();
                Map(x => x.TableOfContents).Not.Nullable();
                Map(x => x.Description).Not.Nullable();
                References(x => x.Category).Column("CategoryId");

                HasManyToMany(u => u.Tags)
                .Table("BookTag")
                .ParentKeyColumn("BookId")
                .ChildKeyColumn("TagId");

            }
        }

      
    }
}

Biblioteka/Controllers/AuthorController.cs
using Biblioteka.Models;
using Biblioteka.Models.Identity;
using Microsoft.AspNet.Identity;
using NHibernate;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Biblioteka.Controllers
{
    public class AuthorController : AuthorizationController
    {
        public ActionResult Index()
        {
            using (ISession session = database.MakeSession())
            {
                var authors = session.QueryOver<Author>().List();
                ViewBag.Role = GetRole(session);

                return View(authors);
            }

        }

        public ActionResult Create()
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    if (!IsLogged()) return RedirectToAction("Login", "Account");
                    ValidateReaderForbiddenAccess(session);
                    
                    return View("Create");
                }


            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");

                

            }
            catch (Exception)
            {
                return RedirectToAction("Index", "Home");
            }

        }

        [HttpPost]
        public ActionResult Create(Author author)
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    using (var transaction = session.BeginTransaction())
                    {
                        session.SaveOrUpdate(author);

                        transaction.Commit();
                        session.Close();

                    }
                }

                return Redirect(Request.UrlReferrer.ToString());
            }
            catch (Exception e)
            {
                return View(author);
            }

        }

        public ActionResult Details(int id)
        {
            using (ISession session = database.MakeSession())
            {
                var author = session.Get<Author>(id);
                return View(author);
            }
        }

        public ActionResult Edit(int id)
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    if (!IsLogged()) return RedirectToAction("Login", "Account");

                    ValidateReaderForbiddenAccess(session);


                    var author = session.Get<Author>(id);
                    return View(author);
                }
            }

            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index", "Home");
            }
        }

        [HttpPost]
        public ActionResult Edit(int id, Author author)
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    var authorData = session.Get<Author>(id);

                    authorData.Name = author.Name;
                    authorData.Surname = author.Surname;
                    authorData.YearOfBirth = author.YearOfBirth;

                    using (ITransaction transaction = session.BeginTransaction())
                    {
                        session.Save(authorData);
                        transaction.Commit();
                    }
                }
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }



        public ActionResult Delete(int id)
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    if (!IsLogged()) return RedirectToAction("Login", "Account");

                    ValidateReaderForbiddenAccess(session);


                    var author = session.Get<Author>(id);
                    return View(author);
                }
            }

            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }

            catch (Exception)
            {
                return RedirectToAction("Index", "Home");
            }
        }

        [HttpPost]
        public ActionResult Delete(int id, Author author)
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    using (ITransaction transaction = session.BeginTransaction())
                    {
                        var authorToDelete = session.Get<Author>(id);
                        session.Delete(authorToDelete);
                        transaction.Commit();
                        session.Close();
                    }
                }
                return RedirectToAction("Index");
            }
            catch (Exception )
            {
                return View();
            }
        }
    }
}

Biblioteka/Controllers/TagController.cs
using Biblioteka.Models;
using NHibernate;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Biblioteka.Controllers
{
    public class TagController : AuthorizationController
    {
        // GET: Tag
        public ActionResult Index()
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    if (!IsLogged()) return RedirectToAction("Login", "Account");
                    ValidateReaderForbiddenAccess(session);
                    var tags = session.QueryOver<Tag>().List();
                    ViewBag.Role = GetRole(session);
                    return View(tags);
                }
            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index");
            }
        }

        public ActionResult Create()
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    if (!IsLogged()) return RedirectToAction("Login", "Account");
                    ValidateReaderForbiddenAccess(session);
                }
                return View();
            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index");
            }
        }

        [HttpPost]
        public ActionResult Create(Tag tag)
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    if (ModelState.IsValid)
                    {
                        using (var transaction = session.BeginTransaction())
                        {
                            session.SaveOrUpdate(tag);

                            transaction.Commit();
                            session.Close();

                        }
                        return RedirectToAction("Index");

                    }
                    else
                    {
                        return View(tag);
                    }
                }
            }
            catch (Exception)
            {
                return View();
            }


        }

        public ActionResult Delete(int id)
        {
            try
            {
                if (!IsLogged()) return RedirectToAction("Login", "Account");
                using (ISession session = database.MakeSession())
                {
                    ValidateReaderForbiddenAccess(session);
                    var tag = session.Get<Tag>(id);
                    return View(tag);
                }
            }catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index");
            }
        }

        [HttpPost]
        public ActionResult Delete(int id, Tag tag)
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    using (ITransaction transaction = session.BeginTransaction())
                    {
                        var tagToDelete = session.Get<Tag>(id);
                        session.Delete(tagToDelete);
                        transaction.Commit();

                        session.Close();
                    }
                }
                return RedirectToAction("Index");
            }
            catch (Exception exception)
            {
                return View();
            }
        }

        public JsonResult IsTagNameExist(string name)
        {
            using (ISession session = database.MakeSession())
            {
                bool exists = session.QueryOver<Tag>().Where(x => x.Name == name).RowCount() > 0;
                if (exists)
                {
                    return Json(false, JsonRequestBehavior.AllowGet);
                }
                else
                {
                    return Json(true, JsonRequestBehavior.AllowGet);
                }
            }
        }
    }
}

Biblioteka/Views/Book/AssignCopies.cshtml
@model Biblioteka.Models.Book

@{
    ViewBag.Title = "AssignCopies";
}



<div>
    <dov class="header-title">Assign new copies</dov>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Title)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Title)
        </dd>
        <dt>
            Author
        </dt>

        <dd>
            @ViewBag.Author
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ISBN)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ISBN)
        </dd>

    </dl>
</div>


@using (Html.BeginForm())
{
    <hr />
    <div class="form-horizontal">

        <div class="form-group">
            <p class="control-label col-md-2">  Number of new copies </p>
            <div class="col-md-2">
                <input name="numberOfCopies" class="form-control" type="number" width="100" />

            </div>
            <div class="col-md-8"></div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-2">
                <input type="submit" value="Assign copies" class="btn default-button" />
            </div>
            <div class="col-md-8"></div>
        </div>
       

    </div>
}
@if (ViewBag.Ids != null)
{
    <h4 class="control-label">All assigned copies </h4>
    <div style="display:flex;">
        <div class="col-md-4" style="display:flex;">


            <table class="table table-striped">
                <thead>
                    <tr>
                        <th>Id</th>
                        <th>Availability</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (var id in ViewBag.Ids)
                {
                        <tr>
                            <td>@id.Id</td>
                            <td>@id.Status</td>
                        </tr>
                    }
                </tbody>

            </table>
        </div>
        <div class="col-md-8" style="display:flex;"></div>
    </div>
}


<div>
    @Html.ActionLink("Back to List", "Index", null, new { @class = "redirect-button" })
</div>

Biblioteka/Views/Book/Create.cshtml
@model Biblioteka.Models.Book

@{
    ViewBag.Title = "Create";
}


<link href="~/Content/Site.css" rel="stylesheet" />
@using (Html.BeginForm("Create", "Book", FormMethod.Post, new { enctype = "multipart/form-data" }))
{


    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <h4>Add new book</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.Title, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Title, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Title, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ISBN, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ISBN, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ISBN, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
            </div>
        </div>


        <div class="form-group">
            <label class="control-label col-md-2">  Author </label>
            <div class="col-md-6 form-inline">
                @Html.DropDownList("AuthorType", null, new { @class = "form-control" })
                @Html.ActionLink("Add new", "Create", "Author", null, new { @class = "btn btn-default" })
            
            </div>
        </div>
        <div class="form-group">
            <label class="control-label col-md-2">  Category </label>
            <div class="col-md-6  form-inline">
                @Html.DropDownList("CategoryType", null, new { @class = "form-control" })
                @Html.ActionLink("Add new", "Create", "Category", null, new { @class = "btn btn-default" })

            </div>
        </div>

        <div class="form-group">
            <label class="control-label col-md-2"> Tags </label>
            <div class="col-md-6 form-inline">
                @Html.ListBox("Tags", ViewBag.Tagslist as MultiSelectList, new { @class = "form-control", @multiple = "true" })
                @Html.ActionLink("Add new", "Create", "Tag", null, new { @class = "btn btn-default" })


            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.TableOfContents, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <input type="file" name="file" accept="application/pdf"  />
                @Html.ValidationMessageFor(model => model.TableOfContents, "", new { @class = "text-danger" })

            </div>

        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create new book" class="btn default-button" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index", null, new { @class = "redirect-button" })
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Biblioteka/Views/Book/Delete.cshtml
@model Biblioteka.Models.Book

@{
    ViewBag.Title = "Delete";
}


<div class="header-title">Are you sure you want to delete this?</div>
<div>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Title)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Title)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ISBN)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ISBN)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.TableOfContents)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.TableOfContents)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn default-button" /> |
            @Html.ActionLink("Back to List", "Index", null, new {@class = "redirect-button"})
        </div>
    }
</div>

Biblioteka/Views/Book/Details.cshtml
@using Microsoft.AspNet.Identity;
@using Biblioteka.Models.Identity;
@using Biblioteka.Models;
@using NHibernate;
@using Biblioteka.Enums
@model Biblioteka.Models.Book

<script src="~/Scripts/validationCart.js"></script>

<div>
    <div class="header-title">@Html.DisplayFor(model=> model.Title)</div>
    <hr />
    <dl class="dl-horizontal">

        <dt class="list-item">
            Author
        </dt>

        <dd class="list-item">
            @ViewBag.Author
        </dd>

        <dt class="list-item">
            @Html.DisplayNameFor(model => model.ISBN)
        </dt>

        <dd class="list-item">
            @Html.DisplayFor(model => model.ISBN)
        </dd>

        <dt class="list-item">
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd class="list-item">
            @Html.DisplayFor(model => model.Description)
        </dd>
        
        <dt class="list-item">
            Category
        </dt>

        <dd class="list-item">
            @ViewBag.Category
        </dd>

        <dt class="list-item">
            Tags
        </dt>

        <dd class="list-item">
            @ViewBag.Tags
        </dd>

        <dt class="list-item">
            @Html.DisplayNameFor(model => model.TableOfContents)
        </dt>

        <dd class="list-item">
            
            @using (Html.BeginForm())
            {

                if (Model.TableOfContents != "")
                {
                    <button class="btn default-button" value=1 type="submit" name="download">
                        Download
                    </button>
                }
                else
                {
                    <button class="btn .btn-default" value=1 type="submit" name="download" disabled>
                        Download
                    </button>
                }
            
            }
        </dd>

    </dl>
</div>

<hr/>

<div style="display:flex;">
    <div class="col-md-4" style="display:flex;">
        @using (Html.BeginForm())
        {
            if (ViewBag.CopiesCount != 0)
            {
            <table class="table table-striped">
                <thead>
                    <tr>
                        <th>Signature</th>
                        <th>Availability</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (var id in ViewBag.Ids)
                    {
                        <tr>
                            <td class="book-signature">@id.Id</td>
                            @if (id.Status == Status.IN_STOCK)
                            {
                                <td>
                                    <img class="book-availability-img" src="~/images/book_free.png"/>
                                </td>
                            }
                            else
                            {
                                <td>
                                    <img class="book-availability-img" src="~/images/book_rented.png"/>
                                </td>
                            }

                            @if (!ViewBag.Added && @ViewBag.Role == UserRole.READER_ROLE)
                            {
                                if (id.Status == Status.IN_STOCK)
                                {
                                    <td>
                                        <button class="btn btn-success" type="submit" name="cart" value="@id.Id">
                                            <span class="glyphicon glyphicon-shopping-cart"></span>Add to cart
                                        </button>
                                    </td>
                                }
                                else
                                {
                                    <td>
                                        <button class="btn btn-warning" type="submit" name="queue" value="@id.Id">
                                            <span class="glyphicon glyphicon-star-empty"></span>Add to queue
                                        </button>


                                    </td>



                                }
                            }

                        </tr>
                    }
                </tbody>

            </table>
            }
        }
    </div>
    <div class="col-md-8" style="display:flex;"></div>
</div>




@{
    if (@ViewBag.Role == UserRole.EMPLOYEE_ROLE)
    {
        <p>
            @Html.ActionLink("Assign Copies", "AssignCopies", new { id = Model.Id }, new { @class = "redirect-button" }) |
            @Html.ActionLink("Back to List", "Index", null, new { @class = "redirect-button" })
        </p>
    }
    else
    {
       <p>
           @Html.ActionLink("Back to List", "Index", null, new { @class = "redirect-button" })
       </p>           
    }
}

Biblioteka/Views/Book/Index.cshtml
@model IEnumerable<Biblioteka.ModelViews.BookIndexView>
@using Biblioteka.Models.Identity;

<link href="~/Content/Site.css" rel="stylesheet" type="text/css" />
<script src="~/Scripts/togglableTabs.js"></script>

<div class="header-title">All books</div>
<p>
    @{
        if (@ViewBag.Role == UserRole.EMPLOYEE_ROLE)
        {
            @Html.ActionLink("Create New", "Create", null, new { @class = "redirect-button" })
        }
    }

</p>

<div class="tab">
    <button class="tablinks" onclick="openSearching(event, 'AllSearch')">Searching</button>
    <button class="tablinks" onclick="openSearching(event, 'TagsSearch')">Searching by tags</button>
    <button id="up" class="tablinks navbar-right" disabled onclick="closeTab(event, 'up')">
        <img src="~/images/up-arrow2.png" height="16" width="16" />
    </button>
</div>


<div id="AllSearch" class="tabcontent">
    @using (Html.BeginForm())
    {
        @Html.AntiForgeryToken()

        <table>
            <tr>
                <th style="padding-left:10px">
                    Title
                </th>
                <th style="padding-left:10px">
                    Author
                </th>
                <th style="padding-left:10px">
                    Category
                </th>

                <th>

                </th>
            </tr>
            <tr>
                <th>
                    <input type="text" name="titleText" value="" class="form-control" />
                </th>
                <th>
                    <input type="text" name="authorText" value="" class="form-control" />
                </th>
                <th>
                    <input type="text" name="categoryText" value="" class="form-control" />
                </th>

                <th>
                    <input type="submit" value="Search" class="btn default-button" style="margin:10px" />
                </th>
            </tr>
        </table>
    }
</div>

<div id="TagsSearch" class="tabcontent">
    @using (Html.BeginForm())
    {
        @Html.AntiForgeryToken()

        <table>
            <tr>
                <th>
                    Tags
                </th>
                <th>

                </th>
            </tr>
            <tr>
                <th style="margin:10px">
                    @Html.ListBox("Tags", ViewBag.Tagslist as MultiSelectList, new { @class = "form-control", @style = "width:300px; height:200px;", @multiple = "true" })
                </th>
                <th>
                    <input type="submit" value="Search" class="btn default-button" style="margin:10px;" />
                </th>
            </tr>
        </table>
    }
</div>


<p style="margin:60px"></p>

<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.Title)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Author)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Category)
        </th>
        <th></th>
        <th></th>
        <th></th>
    </tr>

    @foreach (var item in Model)
            {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.Title)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Author)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Category)
            </td>

            @{
                if (@ViewBag.Role == UserRole.EMPLOYEE_ROLE)
                {
                    <td class="icon-td">
                        <a href="@Url.Action("Details", "Book", new {id = item.Id})">

                            <img src="~/images/details.png" class="link-img" />
                        </a>
                    </td>
                    <td class="icon-td">
                        <a href="@Url.Action("AssignCopies", "Book", new {id = item.Id})">

                            <img src="~/images/add-books.png" class="link-img" />
                        </a>
                    </td>
                    <td class="icon-td">
                        <a href="@Url.Action("Delete", "Book", new {id = item.Id})">

                            <img src="~/images/remove.png" class="link-img" />
                        </a>
                    </td>

                }

                else
                {
                    <td class="icon-td">
                        <a href="@Url.Action("Details", "Book", new {id = item.Id})">

                            <img src="~/images/details.png" class="link-img" />
                        </a>
                    </td>
                }
            }


        </tr>
                }

</table>